/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilit dportes      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");

/**
 * @classDescription    Une classe reprsentant une communication
 * @constructor
 * @return {Object} un objet Communication initialis  vide
 */
function Communication () {}

Communication.prototype = {
    Id_Prospect: "",
    Id_Communication: 0,
    Id_Canal: 0,
    Id_Initiateur: 0,
    Date_Communication: 0,
    Commentaire_Communication: "",
    Mode: "N",
    
    selectionner: function() {
        var req_communication = new QueryHttp("CRM/Communications/selectionnerCommunication.tmpl");
        req_communication.setParam("Id_Communication", this.Id_Communication);
        var req = req_communication.execute();
        return req;
    },
    
    enregistrer: function() {
        var req_enregistrement = new QueryHttp("CRM/Communications/enregistrerCommunication.tmpl");
        req_enregistrement.setParam("Id_Prospect", this.Id_Prospect);
        req_enregistrement.setParam("Id_Canal", this.Id_Canal);
        req_enregistrement.setParam("Id_Initiateur", this.Id_Initiateur);
        req_enregistrement.setParam("Id_Communication", this.Id_Communication);
        req_enregistrement.setParam("Mode", this.Mode);
        req_enregistrement.setParam("Commentaire_Communication", this.Commentaire_Communication);
        req_enregistrement.setParam("Date_Communication", prepareDateHeureJava(this.Date_Communication));
        var req = req_enregistrement.execute();
        return req;
    },
    
     supprimer: function() {
        var req_suppression = new QueryHttp("CRM/Communications/supprimerCommunication.tmpl");
        req_suppression.setParam("Id_Communication", this.Id_Communication);
        var req = req_suppression.execute();
        return req;
    },
    
    /* Vrifier les paramtres
     * 
     * @exception {DateFormatException} si une date est invalide
     */
    verifier: function() {
        if (this.Date_Communication != 0 && !isDateHeure(this.Date_Communication))
            throw "DateFormatException";
    },
    
    setDefauts: function() {
        this.Id_Prospect = "";
        this.Id_Communication = 0;
        this.Id_Canal = 0;
        this.Id_Initiateur = 0;
        this.Date_Communication = 0;
        this.Commentaire_Communication = "";
        this.Mode = "N";
    }
}
