/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilit dportes      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

jsLoader.loadSubScript("chrome://opensi/content/libs/formatter.js");

var nf2 = new NumberFormat("00", false);

/**
 * @classDescription    Une classe reprsentant un widget lment de date + heure
 * @constructor
 * 
 * @param {string} id_jour    id du champ qui contient le jour
 * @param {string} id_mois    id du champ qui contient le mois
 * @param {string} id_anne   id du champ qui contient l'anne
 * @param {string} id_heure   id du champ qui contient l'heure
 * @param {string} id_jour    id du champ qui contient la minute
 * @return {Object} un objet DateHeureWidget initialis  vide
 */
function DateHeureWidget(id_jour, id_mois, id_annee, id_heure, id_minute) {
    this.id_jour = id_jour;
    this.id_mois = id_mois;
    this.id_annee = id_annee;
    this.id_heure = id_heure;
    this.id_minute = id_minute;
}

DateHeureWidget.prototype = {
    allerSuivant: function(zone) {
        var next;
        if (zone.maxLength == zone.textLength) {
            switch (zone.getAttribute("id")) {
                case this.id_jour:
                    next = document.getElementById(this.id_mois);
                    break;
                case this.id_mois:
                    var annee = document.getElementById(this.id_annee);
                    if (annee.maxLength == annee.textLength)
                        next = document.getElementById(this.id_heure);
                    else
                        next = annee;
                    break;
                case this.id_annee:
                    next = document.getElementById(this.id_heure);
                    break;
                case this.id_heure:
                    next = document.getElementById(this.id_minute);
                    break;
            }
            next.focus();
        }
    },
    
    setAujourdhui: function () {
        var d = new Date();
        document.getElementById(this.id_jour).value = nf2.format(d.getDate());
        document.getElementById(this.id_mois).value = nf2.format(d.getMonth() + 1);
        document.getElementById(this.id_annee).value = d.getFullYear();
        document.getElementById(this.id_heure).value = nf2.format(d.getHours());
        document.getElementById(this.id_minute).value = nf2.format(d.getMinutes());
    },
    
    getPlanning: function() {
        var date = this.getDatePlanning();
        var heure = this.getHeurePlanning();
        if (date == "" && heure == "")
            return 0;
        return  date + ":" + heure;
    },
    
    getDatePlanning: function() {
        var jour = nf2.format(document.getElementById(this.id_jour).value); 
        var mois = nf2.format(document.getElementById(this.id_mois).value);
        if (jour == "00" && mois == "00")
            return "";
        return  jour + ":" + mois + ":" + document.getElementById(this.id_annee).value;
    },
    
    getHeurePlanning: function() {
        var h = nf2.format(document.getElementById(this.id_heure).value);
        var mn = nf2.format(document.getElementById(this.id_minute).value);
        if (h == '00' && mn == "00")
            return "";
        return h + ":" + mn;
    },
    
    setDateHeure: function(jour, mois, annee, heure, minute) {
        document.getElementById(this.id_jour).value = jour;
        document.getElementById(this.id_mois).value = mois;
        document.getElementById(this.id_annee).value = annee;
        document.getElementById(this.id_heure).value = heure;
        document.getElementById(this.id_minute).value = minute;
    },
    
    estDateHeure: function() {
        return (document.getElementById(this.id_jour).value != "" ||
                document.getElementById(this.id_mois).value != "" ||
                document.getElementById(this.id_annee).value != "" ||
                document.getElementById(this.id_heure).value != "" ||
                document.getElementById(this.id_minute).value != "");
    },
    
    enable: function() {
        document.getElementById(this.id_jour).disabled = false;
        document.getElementById(this.id_mois).disabled = false;
        document.getElementById(this.id_annee).disabled = false;
        document.getElementById(this.id_heure).disabled = false;
        document.getElementById(this.id_minute).disabled = false;
    },
    
    disable: function() {
        document.getElementById(this.id_jour).disabled = true;
        document.getElementById(this.id_mois).disabled = true;
        document.getElementById(this.id_annee).disabled = true;
        document.getElementById(this.id_heure).disabled = true;
        document.getElementById(this.id_minute).disabled = true;
    }
}
