/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/formatter.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/lib_tva.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");

var devis_id;
var mode_ligne;
var mode;
var etat_devis;
var mode_tarif;
var currentRank = 0;
var type_remise = 'P';
var editionTTC = false;
var assujettiTVA = false;
var tva_port;
var currentTotalHT = 0;
var currentMontantTTC = 0;
var zoneUE=false;


var nf = new NumberFormat("0.00", false);

function init() {
  try {
    
  	    var qParam = new QueryHttp("Config/gestion_commerciale/preferences/getParam.tmpl");
		var result = qParam.execute();
		
		var act_code_stats = (parseInt(result.responseXML.documentElement.getAttribute('Act_Code_Stats'))==1);
		var produit_frais = (parseInt(result.responseXML.documentElement.getAttribute('Produit_Frais'))==1);
		if (!act_code_stats) {
			document.getElementById('ColCode_Stats').collapsed = true;
		}
		
		if (!produit_frais) {
			document.getElementById('ColNum_Lot').collapsed = true;
			document.getElementById('ColNb_Pieces').collapsed = true;
			document.getElementById('ColUnite').collapsed = true;
			document.getElementById('ColDate_Peremption').collapsed = true;
		}

		var aCodesTarifs = new Arbre("fact", "liste_types_tarifs.tmpl", "Code_Tarif");
		aCodesTarifs.initTree(initCodeTarif);

		setModeTarif();
		
		var aPays = new Arbre("fact", "liste_pays.tmpl", "Code_Pays_Fact");
		aPays.initTree(initPaysFact);
		
		document.getElementById('poidsTotal').value = 0;

	} catch (e) {
  	    recup_erreur(e);
	}
}

function initCodeTarif() {
	try {
		document.getElementById('Code_Tarif').selectedIndex=0;
	} catch (e) {
		recup_erreur(e);
	}
}

function initPaysFact() {
	try {
    
        var aPaysLiv = new Arbre("fact", "liste_pays.tmpl", "Code_Pays_Liv");
		aPaysLiv.initTree(initPaysLiv);

	} catch (e) {
        recup_erreur(e);
    }
}


function initPaysLiv() {
	try {

        var paramlist = "&Page=Facturation/GetRDF/liste_commerciaux.tmpl&ContentType=xml";
  	    load_rdf_async('Login_Resp', getUrlOpeneas(paramlist), initResp);

	} catch (e) {
    recup_erreur(e);
  }
}


function initResp() {
  try {

		document.getElementById('Login_Resp').value = get_cookie("User");

		// chargement
		devis_id = ParamValeur("Devis_Id");

		init_tree();
		
		var queryLoadTemp = new QueryHttp("Facturation/Devis/loadArticleDevisTemp.tmpl");
		queryLoadTemp.setParam("Devis_Id", devis_id);
		queryLoadTemp.execute();
		
		calculerPoids();

	} catch (e) {
  	    recup_erreur(e);
	}
}

function selectPaysLiv() {
	try {
        changerTypeVente();
	} catch (e) {
		recup_erreur(e);
	}
}

function changerTypeVente() {
	try {
	    var qTypeVente = new QueryHttp("GetPays.tmpl");
	    qTypeVente.setParam("Code_Pays", document.getElementById("Code_Pays_Liv").value);
	    var result = qTypeVente.execute();
	    zoneUE = (result.responseXML.documentElement.getAttribute("zone_ue")=="1");
	} catch(e) {
		recup_erreur(e);
	}
}

function setModeTarif() {
	try {

        var corps = cookie() +"&Page=Config/gestion_commerciale/preferences/getParam.tmpl&ContentType=xml";
        var p = requeteHTTP(corps);

		mode_tarif = p.responseXML.documentElement.getAttribute('Mode_Tarif');

		if (mode_tarif=='Q') {
			document.getElementById('row_tarif').collapsed = true;
		}

	} catch (e) {
		recup_erreur(e);
	}
}

function pressOnWindow(ev) {
	try {

		if (ev.altKey && mode!="V") {
			switch(ev.charCode) {
      	case 97: // 'a'
					rechercherStock();
        	break;
				case 116: // 't'
					modifierTarif();
					break;
    	}
		}

	} catch (e) {
    recup_erreur(e);
  }
}

function modifierTarif() {
	try {

		if (mode_ligne = "M" && document.getElementById('Type_Ligne').value=='S') {

			if (mode_tarif=='Q') {

				var reference = document.getElementById('Reference').value;

				var url = "chrome://opensi/content/facturation/user/commun/popup-choixTarif.xul?"+ cookie() +"&Article_Id="+ urlEncode(reference);
    		window.openDialog(url,'','chrome,modal,centerscreen', reporterTarifId);

				var tarif_id = document.getElementById('Tarif_Id').value;

				if (!isEmpty(tarif_id)) {

					var corps = cookie() +"&Page=Facturation/Affaires/getArticleQte.tmpl&ContentType=xml&Article_Id="+ urlEncode(reference);
					corps += "&Tarif_Id="+ tarif_id;
					corps += "&Type_Prix="+ (editionTTC?"TTC":"HT");

					var p = requeteHTTP(corps);

					var contenu = p.responseXML.documentElement;

					document.getElementById('Quantite').value = contenu.getAttribute("Quantite");
					document.getElementById('Unite').value = contenu.getAttribute("Unite");
					document.getElementById("PU").value = contenu.getAttribute("Prix");
					document.getElementById("Tarif_Id").value = "";
					document.getElementById("Libelle").value = contenu.getAttribute("Libelle");
				}
			}
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function reporterTarifId(tarif_id) {
	try {
		document.getElementById('Tarif_Id').value = tarif_id;
	} catch (e) {
		recup_erreur(e);
	}
}


function calculTotaux() {
    try {
  	    var client_id = document.getElementById("Client_Id").value;
		var client_connu = (client_id!="");

		var tree = document.getElementById("articles");
		document.getElementById('Edition_TTC').disabled = (tree.view==null || tree.view.rowCount>0);
        document.getElementById('Code_Pays_Liv').disabled = (tree.view==null || tree.view.rowCount>0);
		document.getElementById('Regime_TVA').disabled = (tree.view==null || tree.view.rowCount>0);
		document.getElementById('Assujetti_TVA').disabled = (tree.view==null || tree.view.rowCount>0);
		
		var remise = parseFloat(document.getElementById('Remise').value);
		var taux_escompte = parseFloat(document.getElementById('Escompte').value);
		var frais_port = parseFloat(document.getElementById('Frais_Port').value);
		var acompte = parseFloat(document.getElementById('Acompte').value);

		if ((type_remise=='P'?isTaux(remise):isPositiveOrNull(remise)) && isTaux(taux_escompte) && isPositiveOrNull(frais_port)) {

			var montant_tva = 0;
			var montant_ht = 0;
			var montant_ttc = 0;

			if (tree.view!=null) {

				if (editionTTC) {
					for (var i=0;i<tree.view.rowCount;i++) {

						if (getCellText(tree,i,'ColType_Ligne')!="C") {
							var tva  = getTva(getCellText(tree,i,'ColCode_TVA'));
							montant_ttc += parseFloat(getCellText(tree,i,'ColTotal'));
          		montant_tva += parseFloat(getCellText(tree,i,'ColTotal')) * (tva/100) / (tva/100+1);
						}
					}

					var taux_remise = (type_remise=='P'?remise:(montant_ttc==0?0:remise/montant_ttc*100));

					var montant_remise = montant_ttc * parseFloat(taux_remise/100);				

					montant_tva = montant_tva * (1 - parseFloat(taux_remise/100)) + frais_port * (tva_port/100) / (tva_port/100+1);

					var total_ht = montant_ttc - montant_tva - montant_remise + frais_port;			

					var total_ttc = montant_ttc - montant_remise + frais_port;

					currentMontantTTC = total_ttc;
					currentTotalHT = total_ht;

					var montant_escompte = nf.format(total_ttc * parseFloat(taux_escompte/100));

					var net_ttc = total_ttc - montant_escompte - acompte;

					document.getElementById('pttcMontantRemise').value = nf.format(montant_remise);
					document.getElementById('pttcMontantFrais_Port').value = nf.format(frais_port);
					document.getElementById('pttcTVA').value = nf.format(montant_tva);
					document.getElementById('pttcMontantTTC').value = nf.format(montant_ttc);
					document.getElementById('pttcMontantAcompte').value = nf.format(acompte);
					document.getElementById('pttcMontantEscompte').value = nf.format(montant_escompte);
					document.getElementById('pttcTotalTTC').value = nf.format(total_ttc);
					document.getElementById('pttcNetTTC').value = nf.format(net_ttc);
				}				
				else {
					for (var i=0;i<tree.view.rowCount;i++) {

						if (getCellText(tree,i,'ColType_Ligne')!="C") {						
							montant_ht += parseFloat(getCellText(tree,i,'ColTotal'));
          		montant_tva += parseFloat(getCellText(tree,i,'ColTotal')) * getTva(getCellText(tree,i,'ColCode_TVA'))/100;
						}
					}
					
					var taux_remise = (type_remise=='P'?remise:(montant_ht==0?0:remise/montant_ht*100));

					var montant_remise = montant_ht * parseFloat(taux_remise/100);

					var total_ht = montant_ht * (1 - parseFloat(taux_remise/100)) + frais_port;

					montant_tva = montant_tva * (1 - parseFloat(taux_remise/100)) + frais_port * (tva_port/100);

					montant_ttc = total_ht + montant_tva;

					currentMontantTTC = montant_ttc;
					currentTotalHT = total_ht;

					var montant_escompte = nf.format(montant_ttc * parseFloat(taux_escompte/100));

					var total_ttc = montant_ttc - montant_escompte - acompte;

					document.getElementById('MontantHT').value = nf.format(montant_ht);
					document.getElementById('MontantRemise').value = nf.format(montant_remise);
					document.getElementById('MontantFrais_Port').value = nf.format(frais_port);
					document.getElementById('TotalHT').value = nf.format(total_ht);
					document.getElementById('TVA').value = nf.format(montant_tva);
					document.getElementById('MontantTTC').value = nf.format(montant_ttc);
					document.getElementById('MontantAcompte').value = nf.format(acompte);
					document.getElementById('MontantEscompte').value = nf.format(montant_escompte);
					document.getElementById('TotalTTC').value = nf.format(total_ttc);					
				}
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function calculerPoids() {
	try {
		
		var qPoids = new QueryHttp("Facturation/Devis/getPoidsTotal.tmpl");
		qPoids.setParam("Devis_Id", devis_id);
		var p = qPoids.execute();
		
		document.getElementById('poidsTotal').value = p.responseXML.documentElement.getAttribute("Poids");
	} catch (e) {
		recup_erreur(e);
	}
}


function afterRefreshArticles() {
	try {

		calculTotaux();
		scrollToRank();

	} catch (e) {
  	recup_erreur(e);
	}
}


function scrollToRank() {
	try {

		var tree = document.getElementById("articles");

		if (tree.view!=null && tree.view.rowCount>0 && currentRank>0) {

			var tb = document.getElementById("articles").treeBoxObject;
			var i = 0;
			var trouve = false;

			while (!trouve && i<tree.view.rowCount) {
				
				if (parseIntBis(getCellText(tree,i,'ColRank'))>=currentRank) {
					tb.ensureRowIsVisible(i);
					trouve = true;
				}

				i++;
			}
			if (!trouve) tb.ensureRowIsVisible(tree.view.rowCount-1);
		}

	} catch (e) {
  	recup_erreur(e);
	}
}

function init_tree() {
    try {

        var paramlist = "&Page=Facturation/GetRDF/articles_devis.tmpl&ContentType=xml&Devis_Id="+ devis_id;
        load_rdf_async('articles', getUrlOpeneas(paramlist),chargerDevis);

    } catch (e) {
        recup_erreur(e);
    }
}

function delete_tree() {
  try {

    var database = document.getElementById("articles").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('articles').builder.rebuild();

  } catch (e) {
    recup_erreur(e);
  }
}

function chargerDevis() {
  try {

		mode = "M";
		
		document.getElementById('Code_Tarif').disabled = true;
		document.getElementById('bProforma').collapsed = false;

		var corps = cookie() +"&Page=Facturation/Devis/getDevis.tmpl&ContentType=xml&Devis_Id="+ devis_id;

		var p = requeteHTTP(corps);

		var contenu = p.responseXML.documentElement;

		var numero = contenu.getAttribute('Num_Entier');

		document.getElementById('Remise').value = contenu.getAttribute('Remise');
		type_remise = contenu.getAttribute('Type_Remise');
		document.getElementById('Escompte').value = contenu.getAttribute('Escompte');
		document.getElementById('Acompte').value = contenu.getAttribute('Acompte');
		document.getElementById('Frais_Port').value = contenu.getAttribute('Frais_Port');
		document.getElementById('Commentaires').value = contenu.getAttribute('Commentaires');
		document.getElementById('Imp_Com').checked = contenu.getAttribute('Imp_Com')=="1";
		document.getElementById('Date_Devis').value = contenu.getAttribute('Date_Devis');
		document.getElementById('Numero').value = numero;
		document.getElementById('Date_Exp').value = contenu.getAttribute('Date_Exp');

		document.getElementById('Denomination_Fact').value = contenu.getAttribute('Raison_Sociale');
		document.getElementById('Adresse_1_Fact').value = contenu.getAttribute('Adresse');
		document.getElementById('Adresse_2_Fact').value = contenu.getAttribute('Comp_Adresse');
		document.getElementById('Adresse_3_Fact').value = contenu.getAttribute('Adresse_3');
		document.getElementById('Code_Postal_Fact').value = contenu.getAttribute('Code_Postal');
		document.getElementById('Ville_Fact').value = contenu.getAttribute('Ville');
		document.getElementById('Code_Pays_Fact').value = contenu.getAttribute('Code_Pays');
		
		document.getElementById('Denomination_Liv').value = contenu.getAttribute('Denomination_Liv');
		document.getElementById('Adresse_1_Liv').value = contenu.getAttribute('Adresse_1_Liv');
		document.getElementById('Adresse_2_Liv').value = contenu.getAttribute('Adresse_2_Liv');
		document.getElementById('Adresse_3_Liv').value = contenu.getAttribute('Adresse_3_Liv');
		document.getElementById('Code_Postal_Liv').value = contenu.getAttribute('Code_Postal_Liv');
		document.getElementById('Ville_Liv').value = contenu.getAttribute('Ville_Liv');
		document.getElementById('Code_Pays_Liv').value = contenu.getAttribute('Code_Pays_Liv');

		document.getElementById('Civ_Inter_Fact').value = contenu.getAttribute('Civ_Inter');
		document.getElementById('Nom_Inter_Fact').value = contenu.getAttribute('Nom_Inter');
		document.getElementById('Prenom_Inter_Fact').value = contenu.getAttribute('Prenom_Inter');
		document.getElementById('Tel_Inter_Fact').value = contenu.getAttribute('Tel_Inter');
		document.getElementById('Fax_Inter_Fact').value = contenu.getAttribute('Fax_Inter');
		document.getElementById('Email_Inter_Fact').value = contenu.getAttribute('Email_Inter');
		
		document.getElementById('Civ_Inter_Liv').value = contenu.getAttribute('Civ_Inter_Liv');
		document.getElementById('Nom_Inter_Liv').value = contenu.getAttribute('Nom_Inter_Liv');
		document.getElementById('Prenom_Inter_Liv').value = contenu.getAttribute('Prenom_Inter_Liv');
		document.getElementById('Tel_Inter_Liv').value = contenu.getAttribute('Tel_Inter_Liv');
		document.getElementById('Fax_Inter_Liv').value = contenu.getAttribute('Fax_Inter_Liv');
		document.getElementById('Email_Inter_Liv').value = contenu.getAttribute('Email_Inter_Liv');

		document.getElementById('Code_Tarif').value = contenu.getAttribute('Code_Tarif');
		document.getElementById('Regime_TVA').value = contenu.getAttribute('Regime_TVA');
		assujettiTVA = (contenu.getAttribute('Assujetti_TVA')=="1");		
		selectPaysLiv();
		
		var typeEdition = (contenu.getAttribute('Edition_TTC')=="1");
		
		document.getElementById('Edition_TTC').checked = typeEdition;
		
		document.getElementById('Assujetti_TVA').checked = assujettiTVA;
		document.getElementById('Num_TVA').disabled = !assujettiTVA;
		document.getElementById('Num_TVA').value = contenu.getAttribute("Num_TVA_Intra");

		var client_id = contenu.getAttribute('Client_Id');
        document.getElementById('Client_Id').value = client_id;
		var client_connu = (client_id!="");
		
		if (client_connu) {
			document.getElementById('labelClientFact').setAttribute("value", "Client N "+ client_id);
			document.getElementById('labelClientLiv').setAttribute("value", "Client N "+ client_id);
		}
		else {
			document.getElementById('labelClientFact').setAttribute("value", "Client");
			document.getElementById('labelClientLiv').setAttribute("value", "Client");
		}
		
		document.getElementById('Login_Resp').value = contenu.getAttribute('Util_R');
		
		document.getElementById('Creation').label = "Devis cr le "+ contenu.getAttribute('Date_Creation') +" par "+ contenu.getAttribute('Login_Createur');
		document.getElementById('Modification').label = "Dernire modification le "+ contenu.getAttribute('Date_Maj') +" par "+ contenu.getAttribute('Login_Maj');
		document.getElementById('Fiche').label = "Devis N "+ numero;
		document.getElementById('Creation').collapsed = false;
		document.getElementById('Modification').collapsed = false;

		etat_devis = contenu.getAttribute("Etat");
		
        changerTypeEdition(typeEdition);
        
	} catch (e) {
        recup_erreur(e);
    }
}

function init_tree_temp() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/articles_devis.tmpl&ContentType=xml&Temp=true&Devis_Id="+ devis_id;
    load_rdf_async('articles', getUrlOpeneas(paramlist), afterRefreshArticles);
   
   } catch (e) {
       recup_erreur(e);
   }
}

function afficherFichiers() {
	try {
        var url = "chrome://opensi/content/facturation/user/recherches/rech_fichiers.xul?"+ cookie() +"&Type=Devis&Document_Id="+ urlEncode(devis_id);
    	window.openDialog(url,'','chrome,modal,centerscreen');
		
    } catch (e) {
        recup_erreur(e);
    }
}

function visualiserDevis() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le devis ne contient aucune ligne !");
		} else {
			var client_id = document.getElementById("Client_Id").value;
	  	    window.location = "chrome://opensi/content/crm/user/devis/devis.xul?"+ cookie() +"&Devis_Id="+ devis_id +"&Client_Id="+ client_id;
		}

	} catch (e) {
        recup_erreur(e);
    }
}

function editerProforma() {
    try {

		var tree = document.getElementById("articles");

    	if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le devis ne contient aucune ligne !");
		} else {
			var client_id = document.getElementById("Client_Id").value;
			var page = "chrome://opensi/content/facturation/user/devis/devis.xul?"+ cookie();
          page += "&Devis_Id="+ devis_id;
          page += "&Client_Id=" + client_id;
          page += "&Proforma=true";
	  	  window.location = page;
		}

	} catch (e) {
        recup_erreur(e);
    }
}

function changerTypeVente() {
	try {
	  var qTypeVente = new QueryHttp("GetPays.tmpl");
	  qTypeVente.setParam("Code_Pays", document.getElementById("Code_Pays_Liv").value);
	  var result = qTypeVente.execute();
	  zoneUE = (result.responseXML.documentElement.getAttribute("zone_ue")=="1");
	}	catch(e) {
		recup_erreur(e);
	}
}

function changerTypeEdition(chgType) {
	try {

		editionTTC = chgType;
		if (editionTTC) {
			document.getElementById('ColTotal').setAttribute("label", "Total TTC");
			document.getElementById('ColPU').setAttribute("label", "P.U TTC");
			document.getElementById('lblFrais_Port').value = "Frais de port (ttc) :";
			document.getElementById('piedTTC').collapsed = false;
			document.getElementById('piedHT').collapsed = true;
		}
		else {
			document.getElementById('ColTotal').setAttribute("label", "Total HT");
			document.getElementById('ColPU').setAttribute("label", "P.U HT");
			document.getElementById('lblFrais_Port').value = "Frais de port (ht) :";
			document.getElementById('piedTTC').collapsed = true;
			document.getElementById('piedHT').collapsed = false;			
		}
		
		calculTotaux();

	}	catch(e) {
		recup_erreur(e);
	}
}






