/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilit dportes      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

jsLoader.loadSubScript("chrome://opensi/content/ael_libs/util.js");

// liste des overlays chargs par l'oprateur
var tabs_in = null;
var panels_in = null;

/**
 * Initialisation de la fentre
 * 
 * @param {string} id_prospect identifiant du prospect
 */
function init_assistant(id_prospect) {
    try {
        // tableaux de tab et tabpanel
        if (tabs_in == null) {
            tabs_in = new Array();
            panels_in = new Array();
        }
        
        // instance de prospect
        go_prospect = new Prospect();
        
        // ihm
        document.getElementById('rgpCivilite').selectedIndex = 0;
        activerBoutonsAssistant(false);
        document.getElementById('bEnregistrerProspectAssistant').disabled = false;
        
        // paramtrage : pas de valeur de Id_Prospect pour un nouveau prospect
        if (id_prospect == null || id_prospect == undefined || id_prospect == "")
            mode_prospect = "N";
        else {
            mode_prospect = "M";
            go_prospect.Id_Prospect = id_prospect;
            go_prospect.Mode = "M";
        }
        chargerInfosProspect();
        
        var req_etat_civil = new QueryHttp("CRM/civiliteUtilisateur.tmpl");
        req_etat_civil.execute(chargerCiviliteUtilisateur);
        
        try {
            var items = document.getElementById("liste_valeurs_prospect_assistant").menupopup.childNodes;
        } catch (e) { // premire fois
            // charger la liste _aprs_ avoir rcupr la valeur de l'Id_Valeur_Prospect
            load_rdf_async("liste_valeurs_prospect_assistant", 
                     getUrlOpeneas("&Page=CRM/GetRDF/listeValeursProspect.tmpl&ContentType=xml"),
                     function()  { 
                         document.getElementById("liste_valeurs_prospect_assistant").value = go_prospect.Id_Valeur_Prospect;
                     });
        }
        identifiant_prospect = go_prospect.Id_Prospect; // met la valeur  "" ou au code prospect
        
    } catch (e) {
    	recup_erreur("erreur dans crm/user/phoning/overlay_assistant_phoning.js#init_assistant : "+ e);
    }
}

/**
 * Activer/Dsactiver les boutons lis  l'assistant
 * 
 * @param {boolean} etat    drapeau d'activation : true, les boutons sont activs, sinon false
 */
function activerBoutonsAssistant(etat) {
    try {
        var _etat = !etat;
	    document.getElementById('bSupprimerProspectAssistant').disabled = _etat;
        document.getElementById('bEditionPdfAssistant').disabled = _etat;
        document.getElementById('bPasserEnClientAssistant').disabled = _etat;
    } catch (e) {
    	recup_erreur("erreur dans crm/user/phoning/overlay_assistant_phoning.js#activerEtatBoutonsAssistant : "+ e);
    }
}

/**
 * Charge tout l'tat civil de l'utilisateur pour personnaliser le message de contact
 * 
 * @param {XMLHttpRequest} req    requte
 */
function chargerCiviliteUtilisateur(req) {
    try {
        var etat_civil = req.responseXML.documentElement;
        var desc = document.getElementById('aide_contact');
        var aide = desc.firstChild.data.replace(/{user}/, etat_civil.getAttribute('Prenom') + " " + etat_civil.getAttribute('Nom'));
        while (desc.firstChild)
            desc.removeChild(desc.firstChild);
        desc.appendChild(document.createTextNode(aide));
    } catch (e) {
        recup_erreur("erreur dans crm/user/phoning/overlay_assistant_phoning.js#chargerCiviliteUtilisateur : "+ e);
    }
}

/**
 * Charger les infos du prospect si ncessaire
 * 
 */
function chargerInfosProspect() {
    try {
        if (mode_prospect == "M") 
            finChargerInfosProspect(go_prospect.selectionner());
    } catch (e) {
	    recup_erreur("erreur dans crm/user/phoning/overlay_assistant_phoning.js#chargerInfosProspect : "+ e);
    }
}

/**
 * Mettre  jour la fentre en fonction des donnes prospect
 * 
 * @param {XMLHttpRequest} req requte de chargerInfosCaissier
 */
function finChargerInfosProspect(req) {
    try {
        var prospect = req.responseXML.documentElement;
        
        // vrifier qu'on n'est pas dans une requte  prospect suivant  qui 
        // ne renvoie pas de rsultat
        if (!(prospect.hasAttribute("suivant") && prospect.getAttribute("suivant") == "false")) {
            // la civilit est 1, 2, ou 3, l'index est donc la civilit - 1,
            // puisqu'ils sont dans l'ordre
            document.getElementById("rgpCivilite").selectedIndex = parseInt(prospect.getAttribute("Civilite")) - 1;
            document.getElementById("txtIdProspect").value = prospect.getAttribute("Id_Prospect");
            document.getElementById("txtRaisonSociale").value = prospect.getAttribute("Raison_Sociale");
            document.getElementById("txtNom").value = prospect.getAttribute("Nom");
            document.getElementById("txtPrenom").value = prospect.getAttribute("Prenom");
            document.getElementById("txtAdresse").value = prospect.getAttribute("Adresse");
            document.getElementById("txtCompAdresse").value = prospect.getAttribute("Comp_Adresse");
            document.getElementById("txtVille").value = prospect.getAttribute("Ville");
            document.getElementById("txtCodePostal").value = prospect.getAttribute("Code_Postal");
            document.getElementById("txtTel").value = prospect.getAttribute("Tel");
            document.getElementById("txtMobile").value = prospect.getAttribute("Mobile");
            document.getElementById("txtFax").value = prospect.getAttribute("Fax");
            document.getElementById("txtEmail").value = prospect.getAttribute("Email");
            document.getElementById("txtSiteWeb").value = prospect.getAttribute("Site_Web");
            document.getElementById("txtDivers").value = prospect.getAttribute("Divers");
            document.getElementById("chkEtat").checked = (prospect.getAttribute("Etat") == 1);
            document.getElementById("chkMailing").checked = (prospect.getAttribute("Mailing") == 1);
            
            afficherBarreStatut(prospect.getAttribute("Date_Creation"),
                                prospect.getAttribute("Login_Createur"),
                                prospect.getAttribute("Date_Maj"),
                                prospect.getAttribute("Login_Maj"));
            
            // mise  jour des tats des boutons
            activerBoutonsAssistant(true);        
            document.getElementById("bEnregistrerProspectAssistant").disabled = false;
            
            // redondance dans les fixations d'attributs pour le retour de prospectSuivant()
            go_prospect.Id_Prospect = prospect.getAttribute("Id_Prospect");
            go_prospect.Etat = prospect.getAttribute("Etat");
            // ncessaire pour charger la liste de valeurs de prospect
            // et mettre l'index  la bonne place
            go_prospect.Id_Valeur_Prospect = prospect.getAttribute("Id_Valeur_Prospect");
            
            // rafraichissement de la fentre pour tat et communications
            rafraichir();
        }                 
    } catch (e) {
	    recup_erreur("erreur dans crm/user/phoning/overlay_assistant_phoning.js#finChargerInfosProspect : "+ e);
    }
}

/**
 * Charger les infos du prospect suivant selon les critres de recherche
 */
function prospectSuivant() {
    try {
        resetAssistant(); // remet tout  zro
        
	    go_prospect.Etat = critere_etat;
	    go_prospect.Interet = critere_interet;
        go_prospect.Id_Prospect = identifiant_prospect;
        go_prospect.Id_Valeur_Prospect = critere_valeur;
        go_prospect.Raison_Sociale = critere_rs;
        finChargerInfosProspect(go_prospect.selectionnerSuivant());
        identifiant_prospect = go_prospect.Id_Prospect;
        mode_prospect = "M";
    } catch (e) {
	    recup_erreur("erreur dans crm/phoning/overlay_assistant_phoning.js#prospectSuivant : "+ e);
    }
}

/**
 * Ajouter un observateur  la liste
 * 
 * @param {AssistantObservateur} obs    observateur  ajouter
 */
function ajouterObservateur(obs) {
    try {
	    go_gest_obs.ajouterObservateur(obs);
    } catch (e) {
        recup_erreur('erreur dans crm/user/phoning/overlay_assistant_phoning.js#ajouterObservateur : '+ e);
    }
}

/**
 * enregister un tab
 * 
 * @param {Object} tab    le tab cr  la cration de l'overlay
 * @return {boolean} true si le tab est enregistr, false sinon
 */
function enregisterTab(tab) {
    if (rechercherTab(tab) == -1) {
        tabs_in.push(tab);
        return true;
    }
    return false;
}

/**
 * Rechercher un tab enregistr
 * 
 * @param {Object} tab    le tab dont on cherche l'existence
 * @return {int} l'index du tab si il est trouv, -1 sinon
 */
function rechercherTab(tab) {
    try {
        for (var i = 0; i < tabs_in.length; i++)
            if (tabs_in[i].getAttribute("id") == tab.getAttribute("id"))
                return i;
        return -1;
    } catch (e) {
        recup_erreur('erreur dans crm/user/phoning/overlay_assistant_phoning.js#rechercherTab : '+ e);
    }
}

/**
 * Rechercher un tab enregistr par son id
 * 
 * @param {String} id    l'identifiant du tab dont on cherche l'existence
 * @return {int} l'index du tab si il est trouv, -1 sinon
 */
function rechercherTabParId(id) {
    try {
        for (var i = 0; i < tabs_in.length; i++)
            if (tabs_in[i].getAttribute("id") == id)
                return i;
        return -1;
    } catch (e) {
        recup_erreur('erreur dans crm/user/phoning/overlay_assistant_phoning.js#rechercherTabParId : '+ e);
    }
}

/**
 * Ajouter un tab
 * 
 * @param {String} tab_label      tiquette du tab
 * @param {String} tab_panel_id   id du panel raccroch au tab
 * @param {String} overlay        nom de l'overlay, qui doit se situer dans phoning, sans son extension
 */
function ajouterTab(tab_label, tabpanel_id, overlay) {
    try {
        if (verifierExistence("tab_" + tabpanel_id)) { // le tab n'est pas cr
            var tabs = document.getElementById("tabs_assistant");
            var tabpanels = document.getElementById("panels_assistant");
            var nouveau_tab;
            
            // vrifier si l'lment existe
            var tab_index = rechercherTabParId("tab_" + tabpanel_id);
            if (tab_index != -1) {
                tabs.appendChild(tabs_in[tab_index]);
                tabpanels.appendChild(panels_in[tab_index]);
                nouveau_tab = tabs_in[tab_index];
                var obs = go_gest_obs.rechercherObservateurParId(overlay);
                if (obs != null) {
                    obs.init();
                    obs.activer();
                }
            } else {
                // ajouter le tab
                nouveau_tab = tabs.appendItem(tab_label);
                nouveau_tab.setAttribute("linkedpanel", tabpanel_id);
                nouveau_tab.setAttribute("removeelement", "true");
                nouveau_tab.setAttribute("id", "tab_" + tabpanel_id);
                tabs.appendChild(nouveau_tab);
            
                // ajouter le panel attach
                var nouveau_panel = document.createElement("tabpanel");
                nouveau_panel.setAttribute("id", tabpanel_id);
                nouveau_panel.setAttribute("removeelement", "true");
                tabpanels.appendChild(nouveau_panel);
            
                // enregistrer le tab et son panel
                document.loadOverlay("chrome://opensi/content/crm/user/phoning/" + overlay + ".xul", null);
                enregisterTab(nouveau_tab);
                panels_in.push(nouveau_panel);
            }
            tabs.advanceSelectedTab(1);
            tabs.selectedItem = nouveau_tab;
        }
    } catch (e) {
        recup_erreur('erreur dans crm/user/phoning/overlay_assistant_phoning.js#ajouterTab : '+ e);
    } 
}

/**
 * Active le bouton d'enregistrement si il y a eu modification de la fiche.
 *
 * @param {boolean} m    valeur boolenne du drapeau
 */
function setAssistantModifie(m) {
    document.getElementById("bEnregistrerProspectAssistant").disabled = false;
}

/**
 * Vrifie l'existence d'un lment
 * 
 * @return {boolean} true si il n'existe pas
 */
function verifierExistence(id) {
    try {
        return (document.getElementById(id) == null);
    } catch (e) {
        recup_erreur('erreur dans crm/user/phoning/overlay_assistant_phoning.js#verifierExistence : '+ e);
    } 
}

/**
 * Remet l'assistant dans un tat vierge
 */
function resetAssistant() {
    try {
        resetTabs();
        
        document.getElementById("rgpCivilite").selectedIndex = 0;
        document.getElementById("txtIdProspect").value = "";
        document.getElementById("txtRaisonSociale").value = "";
        document.getElementById("txtNom").value = "";
        document.getElementById("txtPrenom").value = "";
        document.getElementById("txtAdresse").value = "";
        document.getElementById("txtCompAdresse").value = "";
        document.getElementById("txtVille").value = "";
        document.getElementById("txtCodePostal").value = "";
        document.getElementById("txtTel").value = "";
        document.getElementById("txtMobile").value = "";
        document.getElementById("txtFax").value = "";
        document.getElementById("txtEmail").value = "";
        document.getElementById("txtSiteWeb").value = "";
        document.getElementById("txtDivers").value = "";
        document.getElementById("liste_valeurs_prospect_assistant").value = 1;
        document.getElementById("chkEtat").checked = false;
        document.getElementById("chkMailing").checked = true;
        document.getElementById("txtCommentaireCommunicationAssistant").value = "";

        nettoyerBarreStatut();
        
        activerBoutonsAssistant(false);
    } catch (e) {
        recup_erreur('erreur dans crm/user/phoning/overlay_assistant_phoning.js#resetAssistant : '+ e);
    } 
}
/**
 * Remet le tableau d'onglet dans sa position initiale, en r-initialisant toutes
 * les valeurs
 */
function resetTabs() {
    try {
        var tabs = document.getElementById("tabs_assistant");
        
        var nb_tabs = tabs.childNodes.length;
        
        if (nb_tabs > 1) { // il y a des tabs ouverts en dehors de contact
            while (nb_tabs > 1) {
                tabs.lastChild.selected = false;
                tabs.removeItemAt(nb_tabs - 1);
                nb_tabs = tabs.childNodes.length;
            }
        }    
        tabs.selectedIndex = 0;
        go_gest_obs.resetTout();
        go_gest_obs.desactiverTout();
        go_prospect.setDefauts();

        action = (document.getElementById("txtIdProspect").value == "" ? true : false);
        document.getElementById('bEnregistrerProspectAssistant').disabled = action;
        activerBoutonsAssistant(!action);
    } catch (e) {
        recup_erreur('erreur dans crm/user/phoning/overlay_assistant_phoning.js#resetTabs : '+ e);
    } 
}

/**
 * Effectuer le paramtrage de l'objet Prospect qui est utilis pour enregistrer, supprimer,
 * passer en client, notamment
 */
function parametrerObjetProspect() {
    try {
	    go_prospect.Id_Prospect = document.getElementById('txtIdProspect').value;
		go_prospect.Raison_Sociale = document.getElementById('txtRaisonSociale').value;
		go_prospect.Civilite = document.getElementById('rgpCivilite').value;
		go_prospect.Nom = document.getElementById('txtNom').value;
		go_prospect.Prenom = document.getElementById('txtPrenom').value;
		go_prospect.Adresse = document.getElementById('txtAdresse').value;
		go_prospect.Comp_Adresse = document.getElementById('txtCompAdresse').value;
		go_prospect.Code_Postal = document.getElementById('txtCodePostal').value;
		go_prospect.Ville = document.getElementById('txtVille').value;
		go_prospect.Tel = document.getElementById('txtTel').value;
		go_prospect.Mobile = document.getElementById('txtMobile').value;
		go_prospect.Fax = document.getElementById('txtFax').value;
		go_prospect.Email = document.getElementById('txtEmail').value;
        go_prospect.Site_Web = document.getElementById("txtSiteWeb").value;
		go_prospect.Divers = document.getElementById('txtDivers').value;
        go_prospect.Etat = document.getElementById("chkEtat").checked ? 1 : 0;
        go_prospect.Mailing = document.getElementById("chkMailing").checked ? 1 : 0;
		go_prospect.Id_Valeur_Prospect = document.getElementById('liste_valeurs_prospect_assistant').value;
        go_prospect.Commentaire_Communication = document.getElementById("txtCommentaireCommunicationAssistant").value;
    } catch (e) {
    	recup_erreur('erreur dans crm/user/phoning/overlay_assistant_phoning.js#parametrerObjetProspect : '+ e);
    }
}

/**
 * Enregistrer les donnes de l'assistant
 */
function enregistrerProspectAssistant() {
    try {
        parametrerObjetProspect();    
    
        if (isEmpty(go_prospect.Adresse)) { showWarning("Veuillez indiquer une adresse."); }
        else if (isEmpty(go_prospect.Ville)) { showWarning("Veuillez indiquer une ville."); }
        else if (!isEmpty(go_prospect.Tel) && !isPhone(go_prospect.Tel)) { showWarning("T\u00E9l\u00e9phone principal incorrect."); }
        else if (!isEmpty(go_prospect.Mobile) && !isPhone(go_prospect.Mobile)) { showWarning("Mobile incorrect."); }
        else if (!isEmpty(go_prospect.Fax) && !isPhone(go_prospect.Fax)) { showWarning("Fax incorrect."); }
        else if (!isEmpty(go_prospect.Email) && !isEmail(go_prospect.Email)) { showWarning("Email incorrect."); }
        else {
            activerBoutonsAssistant(false);
            document.getElementById('bEnregistrerProspectAssistant').disabled = true;
            
            try {
	            // Etat := trait si au moins un tab supplmentaire ouvert
                var traite = 0;
                if (document.getElementById("tabs_assistant").childNodes.length > 1) {
                    traite = 1;
                    go_gest_obs.enregistrerTout(go_prospect);
                }
                // vrification des valeurs d'attributs du prospect
                go_prospect.verifier();
                
                etat = (document.getElementById("chkEtat").checked ? 1 : 0);
                
                // etat est peut-tre dj fix plus haut donc
                go_prospect.Etat = traite | etat;
                
                if (!identifiant_prospect || identifiant_prospect == "") {
                    mode_prospect = "N";
                    go_prospect.Mode = "N";
                // En cas d'exception en enregistrement puis modification de l'identifiant
                // avant r-enregistrement, il faut vrifier que l'id n'ait pas t modifi (tordu !).
                } else { 
                    mode_prospect = "M";
                    go_prospect.Mode = "M";
                }
                
                finEnregistrementProspect(go_prospect.enregistrer());
            } catch (e if e == "DateFormatException") {
	            showWarning("Une date est incorrecte.");
                activerBoutonsAssistant(false);
                document.getElementById("bEnregistrerProspectAssistant").disabled = false;
            }
        }
    } catch (e) {
	    recup_erreur('erreur dans crm/phoning/overlay_assistant_phoning.js#enregistrerProspect : '+ e);
    }
}

/**
 * Fonction de rappel aprs l'enregistrement du prospect
 * 
 * @param {XMLHttpRequest} req resultat d'une requte QueryHttp
 */
function finEnregistrementProspect(req) {
    try {
    	var message = req.responseXML.documentElement.getAttribute("code");
        var creation = req.responseXML.documentElement.getAttribute("Date_Creation");
        var modification = req.responseXML.documentElement.getAttribute("Date_Maj");
        var createur = req.responseXML.documentElement.getAttribute("Login_Createur");
        var modificateur = req.responseXML.documentElement.getAttribute("Login_Maj");
        var id_prospect = req.responseXML.documentElement.getAttribute("Id_Prospect");
        if (message == "existe")
            showWarning("L'identifiant prospect utilis\u00E9 existe. Echec de l'enregistrement");
        else if (message == "echec") {
            showWarning("Echec de l'enregistrement.");
            mode_prospect = "N";
            go_prospect.Mode = "N";
        } else {
            activerBoutonsAssistant(true);
            showMessage("Le prospect est correctement enregistr\u00E9.");
            if (mode_prospect == 'M') 
                afficherBarreStatut(creation, createur, modification, modificateur);
            else {
                afficherBarreStatut(creation, createur);
                go_prospect.Id_Prospect = id_prospect;
            }
            afficherIdProspect(id_prospect);
            mode_prospect = "M";
            identifiant_prospect = go_prospect.Id_Prospect;
            rafraichir();
            setAssistantModifie(false);
        } 
        document.getElementById("bEnregistrerProspectAssistant").disabled = false;
    } catch (e) {
	    recup_erreur('erreur dans crm/user/phoning/overlay_assistant_phoning.js#finEnregistrementProspect : '+ e);
    }
}

/**
 * Afficher l'identifiant de prospect
 * 
 * @param {String} id_prospect identifiant du prospect, pour affichage
 */
function afficherIdProspect(id_prospect) {
    try {
        document.getElementById("txtIdProspect").value = id_prospect; 
        document.getElementById("txtIdProspect").removeAttribute("class"); 
    } catch (e) {
	    recup_erreur('erreur dans crm/user/phoning/overlay_assistant_phoning.js#afficherIdProspect : '+ e);
    }
}

/**
 * Supprimer le prospect de la fiche
 */
function supprimerProspectAssistant() {
    try {
        if (mode_prospect == "M" && 
            confirm("Supprimer ce prospect ?")) {
                go_prospect.Id_Prospect = document.getElementById("txtIdProspect").value;
                var req = go_prospect.supprimer();
                if (req.responseXML.documentElement.getAttribute("code") == "succes") {
                    showMessage("Prospect supprim\u00E9.");
                    retourGestionProspects();
                } else 
                    showWarning("Echec de la suppression.");
                
        } 
    } catch (e) {
	    recup_erreur("erreur dans crm/user/phoning/overlay_assistant_phoning.js#supprimerProspect : "+ e);
    }
}

/**
 * Editer une fiche pdf du prospect, ses paramtres, ses communications et rsolutions
 */
function editerFichePdf() {
    try {
        var url = "chrome://opensi/content/crm/user/prospects/fiche_prospect.xul?" + cookie();
        url += "&Id_Prospect=" + document.getElementById("txtIdProspect").value;
        window.location = url;
    } catch (e) {
    	recup_erreur("erreur dans crm/user/phoning/overlay_assistant_phoning.js#editerFichePdf : "+ e);
    }
}

/**
 * Passer le prospect en client, du moins les renseignements qu'il est possible de passer
 */
function passerEnClient() {
    try {
        parametrerObjetProspect();
        var req = go_prospect.passerEnClient();
        if (req.responseXML.documentElement.getAttribute("code") == "succes")
            showMessage("Le prospect est pass\u00E9 en client. Toutefois, vous devrez finir son paramtrage.");
        else 
            showWarning("Echec du passage client.");
    } catch (e) {
    	recup_erreur("erreur dans crm/user/phoning/overlay_assistant_phoning.js#passerEnClient : "+ e);
    }
}