

/**
 * @classDescription Un observateur pour l'onglet Cong Avec Rdv de l'assistant
 * @return {Object} retourne un nouvel objet AssistantCongeAvecRdv
 * @constructor
 * @inherits AssistantObservateur
 * @param {Object} id    identifiant de l'objet observateur
 */
function AssistantCongeAvecRdv(id) {
    AssistantObservateur.call(this, id);
    this.aide =  "Nous nous retrouverons donc le {date}  {heure} heures{minute}. Je vous remercie.";
}

heriter(AssistantObservateur.prototype, AssistantCongeAvecRdv.prototype);

AssistantCongeAvecRdv.prototype.reset = function() {
    var desc = document.getElementById('aide_conge_avec_rdv');
    while (desc.firstChild)
        desc.removeChild(desc.firstChild);
    desc.appendChild(document.createTextNode(this.aide));
}

AssistantCongeAvecRdv.prototype.init = function() {
    var aide_new = this.aide.replace(/{date}/,
                                 document.getElementById("jour_planning").value + " " +
                                 getMois(parseInt(document.getElementById("mois_planning").value, 10)));
    aide_new = aide_new.replace(/{heure}/, document.getElementById("heure_planning").value);
    var m = document.getElementById("minute_planning").value;
    aide_new = aide_new.replace(/{minute}/, m == '00' ? '' : (' ' + m));
    var node = document.createTextNode(aide_new);
    var old_node = document.getElementById("aide_conge_avec_rdv").childNodes[0];
    document.getElementById("aide_conge_avec_rdv").replaceChild(node, old_node);
}

// cration de l'observateur qui s'enregistre automatiquement
ajouterObservateur(new AssistantCongeAvecRdv("overlay_conge_avec_rdv"));


