/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilit dportes      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

jsLoader.loadSubScript("chrome://opensi/content/libs/formatter.js");

var nf2 = new NumberFormat("00", false);

/**
 * Aller au champ de texte suivant
 * 
 * @param {Object} zone    la zone de texte o est active la commande
 */
function allerSuivant(zone) {
    try {
        var next;
        if (zone.maxLength == zone.textLength) {
            switch (zone.getAttribute("id")) {
                case "jour_planning":
                    next = document.getElementById("mois_planning");
                    break;
                case "mois_planning":
                    var annee = document.getElementById("annee_planning");
                    if (annee.maxLength == annee.textLength)
                        next = document.getElementById("heure_planning");
                    else
                        next = annee;
                    break;
                case "annee_planning":
                    next = document.getElementById("heure_planning");
                    break;
                case "heure_planning":
                    next = document.getElementById("minute_planning");
                    break;
            }
            next.focus();
        }
            //document.commandDispatcher.advanceFocus();
    } catch (e) {
        recup_erreur('erreur dans crm/phoning/overlay_zone_planning.js#allerSuivant : '+ e);
    }
}

/**
 * Renvoie la date complte avec heure
 * 
 *  @return {String} date au format jj:mm:aaaa:hh:mm
 */
function getPlanning() {
    var date = this.getDatePlanning();
    var heure = this.getHeurePlanning();
    if (date == "" && heure == "")
        return 0;
    return  date + ":" + heure;
}

/**
 * Renvoie une date avec les paramtres de la zone de planning
 * 
 * @return {String} date au format jj:mm:aaaa
 * 
 */
function getDatePlanning() {
    var jour = nf2.format(document.getElementById('jour_planning').value); 
    var mois = nf2.format(document.getElementById('mois_planning').value);
    if (jour == "00" && mois == "00")
        return "";
    return  jour + ":" + mois + ":" + document.getElementById("annee_planning").value;
}

/**
 * Renvoie une heure avec les paramtres de la zone de planning
 * 
 * @return {String} heure au format hh:mm
 */
function getHeurePlanning() {
    var h = nf2.format(document.getElementById('heure_planning').value);
    var mn = nf2.format(document.getElementById('minute_planning').value);
    if (h == '00' && mn == "00")
        return "";
    return h + ":" + mn;
}

