/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilité déportées      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


/**
 * Données nécessaires à l'édition d'une fiche prospect standard
 */

package com.ael.crm.actions.documents.modeles;


import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Vector;

import com.ael.crm.metier.Communication;
import com.ael.crm.metier.Resolution;

import org.experlog.openeas.api.Session;


public class DataProspect {

	// coordonnées prospect
	protected String civilite;
	protected String nom;
	protected String prenom;
	protected String raisonSociale;
	protected String adresse;
	protected String compAdresse;
	protected String codePostal;
	protected String ville;
	protected String tel;
	protected String mobile;
	protected String fax;
	protected String email;
	protected String web;
	protected String divers;
	protected String valeur;
	protected int etat;
	protected int mailing;
	
	protected Vector<Communication> communications = new Vector<Communication>();
	
	public DataProspect(Session s, String idProspect) {	
		try {
			Connection conn = s.getConnection(null);
			Statement stmt = conn.createStatement();
      
			String baseCRM = s.getCookie().get("CRMDossier");
			
			ResultSet rset;
      
			// coordonnées du prospect
      
			String reqProspect = "SELECT p.*, civ.Civ_Courte, vp.Intitule_Valeur_Prospect" +
			                     " FROM " + baseCRM + ".PROSPECT p, CIVILITE civ, " + baseCRM + ".VALEUR_PROSPECT vp" +
			                     " WHERE p.Civilite = civ.Civ_Id AND p.Id_Valeur_Prospect = vp.Id_Valeur_Prospect" +
			                     " AND p.Id_Prospect='"+ idProspect +"'";
			rset = stmt.executeQuery(reqProspect);
			rset.next();
			
			this.civilite = rset.getString("Civ_Courte"); 
			this.nom = rset.getString("Nom"); 
			this.prenom = rset.getString("Prenom"); 
			this.raisonSociale = rset.getString("Raison_Sociale");
			this.adresse = rset.getString("Adresse");
			this.compAdresse = rset.getString("Comp_Adresse");
			this.codePostal = rset.getString("Code_Postal");
			this.ville = rset.getString("Ville");
			this.tel = rset.getString("Tel");
			this.mobile= rset.getString("Mobile");
			this.fax = rset.getString("Fax");
			this.email = rset.getString("Email");
			this.web = rset.getString("Site_Web");
			this.divers = rset.getString("Divers");
			this.valeur = rset.getString("Intitule_Valeur_Prospect");
			this.etat = rset.getInt("Etat"); 
			this.mailing = rset.getInt("Mailing"); 
			
			rset.close();
			
			String reqCommunications = "SELECT co.Id_Communication, co.Commentaire_Communication, co.Date_Communication, co.Createur, " +
			                           "ca.Intitule_Canal, ini.Intitule_Initiateur, " +
			                           "COALESCE(r.Id_Resolution, 0) AS Id_Resolution, r.Date_Evenement, r.Responsable, r.Description_Resolution, " +
			                           "pri.Intitule_Priorite, st.Intitule_Statut, ev.Type_Evenement " +
			                           "FROM " + baseCRM + ".COMMUNICATION co JOIN " + baseCRM + ".CANAL ca on co.Id_Canal=ca.Id_Canal " +
			                           "JOIN " + baseCRM + ".INITIATEUR ini ON co.Id_Initiateur=ini.Id_Initiateur " +
			                           "LEFT JOIN " + baseCRM + ".RESOLUTION_COMMUNICATION rc ON co.Id_Communication = rc.Id_Communication " +
			                           "LEFT JOIN " + baseCRM + ".RESOLUTION r  ON rc.Id_Resolution = r.Id_Resolution " +
			                           "LEFT JOIN " + baseCRM + ".PRIORITE pri on r.Id_Priorite = pri.Id_Priorite " +
			                           "LEFT JOIN " + baseCRM + ".STATUT st ON r.Id_Statut = st.Id_Statut " +
			                           "LEFT JOIN " + baseCRM + ".EVENEMENT ev ON r.Id_Evenement = ev.Id_Evenement " +
			                           "WHERE co.Id_Prospect = '" + idProspect + "'";
			rset = stmt.executeQuery(reqCommunications);
			int idCom = 0;
			while(rset.next()) {
				int nIdCom = rset.getInt("Id_Communication");
				Communication com;
				if (nIdCom != idCom) { // nouvelle communication
					com = new Communication(
							rset.getInt("Id_Communication"),
							rset.getString("Intitule_Initiateur"),
							rset.getString("Createur"),
							rset.getString("Intitule_Canal"),
							rset.getString("Commentaire_Communication"),
							rset.getLong("Date_Communication"));
					communications.add(com);
					idCom = nIdCom;
				} else
					com = communications.lastElement();
				ajouterResolution(
						rset.getInt("Id_Resolution"),
						rset.getString("Responsable"),
						rset.getString("Intitule_Statut"),
						rset.getString("Intitule_Priorite"),
						rset.getString("Type_Evenement"),
						rset.getString("Description_Resolution"),
						rset.getLong("Date_Evenement"),
						com);
			}
			
			stmt.close();			
			s.closeConnection(conn, null);
			
		} catch(Exception e) {
			e.printStackTrace();
		}	
	}
	
	public String getNomComplet() {
		return civilite + " " + prenom + " " + nom;
	}
	
	private void ajouterResolution(int idReso,
            					  String responsable,
							      String statut,
							      String priorite,
							      String evenement,
							      String description,
							      long dateEvenement, Communication com) {
		if (idReso != 0) 
			com.ajouterResolution(
				new Resolution(
					idReso,
					responsable,
					statut,
					priorite,
					evenement,
					description,
					dateEvenement));
	}
	
}
